## ifrit 3.0.0

=== build/CMakeLists.txt ===
#
#  Copyright (c) 2002-2006 Nick Gnedin 
#  All rights reserved.
#
#  This file may be distributed and/or modified under the terms of the
#  GNU General Public License version 2 as published by the Free Software
#  Foundation and appearing in the file LICENSE.GPL included in the
#  packaging of this file.
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.0)

SET(src ..)
SET(target ifrit)
PROJECT(${target})

SET(addOGL 0 CACHE BOOL "Add OpenGL manually")
SET(addX11 0 CACHE BOOL "Add X11 manualy")
MARK_AS_ADVANCED(addOGL addX11)

IF(NOT CMAKE_BUILD_TYPE)
       SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

#
# ---------------------------------------------------------------------------
#
# Configuration
#
# ---------------------------------------------------------------------------
#
#  Shells
#
OPTION(Shell:CL "Include command-line shell" ON)
OPTION(Shell:QT "Include Qt-based GUI shell" ON)

SET(nsh)
SET(gsh)

IF(Shell:CL)
	SET(nsh ${nsh} cl)
ENDIF(Shell:CL)

IF(Shell:QT)
	SET(gsh ${gsh} qt)
ENDIF(Shell:QT)

IF(NOT nsh AND NOT gsh)
	MESSAGE(FATAL_ERROR "At least one shell must be selected.")
ENDIF(NOT nsh AND NOT gsh)

#
#  Extensions
#
FILE(GLOB dir ${src}/core/extensions/hart) 
IF(EXISTS ${dir})
	OPTION(Extension:HART "Include HART extension" ON)
ENDIF(EXISTS ${dir})

FILE(GLOB dir ${src}/core/extensions/mv) 
IF(EXISTS ${dir})
	OPTION(Extension:MultiView "Include MultiView extension" ON)
ENDIF(EXISTS ${dir})

SET(ext)
IF(Extension:HART)
	SET(ext ${ext} hart)
ENDIF(Extension:HART)

IF(Extension:MultiView)
	SET(ext ${ext} mv)
ENDIF(Extension:MultiView)

#
# ---------------------------------------------------------------------------
#
#  Find dependencies
#
# ---------------------------------------------------------------------------
#
SET(EXECUTABLE_OUTPUT_PATH ..)
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY CMAKE_INSTALL_PREFIX LIBRARY_OUTPUT_PATH QT_QMAKE_EXECUTABLE)

# Find curses
INCLUDE(${CMAKE_ROOT}/Modules/FindCurses.cmake)
IF(UNIX AND NOT CURSES_LIBRARY)
	IF(Shell:CL)
		MESSAGE(FATAL_ERROR "Curses library is not found, but is needed for Command-Line Shell. Please disable the Command-Line Shell option or install the curses library.")
	ENDIF(Shell:CL)
ENDIF(UNIX AND NOT CURSES_LIBRARY)

# Find VTK
SET(VTK_DIR $ENV{VTKDIR})
INCLUDE(${CMAKE_ROOT}/Modules/FindVTK.cmake)
IF(NOT VTK_FOUND)
	MESSAGE(FATAL_ERROR "VTK is not found. Please check that VTKDIR variables is set properly.")
ENDIF(NOT VTK_FOUND)
INCLUDE(${VTK_USE_FILE})

IF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
	OPTION(CustomVP1000 "Include custom support for VP1000" ON)
ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)

# Find OpenGL
IF(addOGL)
	INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)
	IF(NOT OPENGL_FOUND)
		MESSAGE(FATAL_ERROR "OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
	ENDIF(NOT OPENGL_FOUND)
	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
ENDIF(addOGL)

# Find X11
IF(UNIX AND addX11)
	INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
	IF(NOT X11_FOUND)
		MESSAGE(FATAL_ERROR "X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
	ENDIF(NOT X11_FOUND)
	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
ENDIF(UNIX AND addX11)

IF(Shell:QT)
	# Find Qt
	SET(QT_REQUIRED 1)
	INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
	INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR})
	IF(QT4_INSTALLED)
		INCLUDE_DIRECTORIES(${QT_QT_INCLUDE_DIR})
	ENDIF(QT4_INSTALLED)
	ADD_DEFINITIONS(${QT_DEFINITIONS})
ENDIF(Shell:QT)

#
# ---------------------------------------------------------------------------
#
#  Create the project
#
# ---------------------------------------------------------------------------
#
SET(shell 0)
SET(exten 0)
#
#  Core
#
FILE(GLOB sources ${src}/configure/*.cpp ${src}/core/*.cpp ${src}/help/*.cpp)
INCLUDE_DIRECTORIES(${src}/configure ${src}/core ${src}/help ${src}/docs)

#
#  Shells
#
IF(gsh)
	FILE(GLOB tmp ${src}/shells/configure/*.cpp ${src}/shells/generic/*.cpp ${src}/shells/base/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/shells/configure ${src}/shells/generic ${src}/shells/base)
	ENDIF(tmp)
ENDIF(gsh)

FOREACH(s ${nsh} ${gsh})
	FILE(GLOB tmp ${src}/shells/${s}/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/shells/${s})
		STRING(TOUPPER ${s} us)
		SET(shell ${shell}+ISHELL_${us})
	ENDIF(tmp)
ENDFOREACH(s)

#
#  Extensions
#
FOREACH(e ${ext})
	FILE(GLOB tmp ${src}/core/extensions/${e}/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/core/extensions/${e})
		IF(gsh)
			FILE(GLOB tmp ${src}/shells/generic/extensions/${e}/*.cpp)
			SET(sources ${sources} ${tmp})
			INCLUDE_DIRECTORIES(${src}/shells/generic/extensions/${e})
		ENDIF(gsh)
		STRING(TOUPPER ${e} ue)
		SET(exten ${exten}+IEXTENSION_${ue})
	ENDIF(tmp)
ENDFOREACH(e)

#
#  Special
#
IF(Shell:QT)
	SET(qtdir ${src}/shells/qt)
	SET(qthdr ${qtdir}/iqtwidgettexteditorsubject.h ${qtdir}/iqtwidgethelper.h ${qtdir}/iqtrenderwindowsubject.h ${qtdir}/iqtmenuwindowsubject.h ${qtdir}/iqtmainwindowsubject.h ${qtdir}/iqtframesubject.h)
	SET(tmp)
	QT_WRAP_CPP(dummy tmp ${qthdr})
	SET(sources ${sources} ${tmp})
ENDIF(Shell:QT)

IF(CustomVP1000)
	FILE(GLOB tmp ${src}/special/vp1000/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/special/vp1000)
		ADD_DEFINITIONS(-DI_CUSTOM_VP1000)
	ENDIF(tmp)
ENDIF(CustomVP1000)

IF(WIN32 AND NOT CYGWIN)
	FILE(GLOB tmp ${src}/special/win32/*.rc)
	IF(tmp)
		SET(sources ${sources} ${tmp})
	ENDIF(tmp)
ENDIF(WIN32 AND NOT CYGWIN)

#
#  Create target
#
IF(nsh)
	ADD_EXECUTABLE(${target} ${sources})
ELSE(nsh)
	ADD_EXECUTABLE(${target} WIN32 ${sources})
ENDIF(nsh)

ADD_DEFINITIONS(-DI_EXTERNAL_CONFIGURATION -DI_CHECK1)

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK2)
ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")

#
#  Edition
#
FILE(GLOB tmp ${src}/configure/edition*.cpp)
IF(tmp) 
	ADD_DEFINITIONS(-DI_EDITION)
ENDIF(tmp) 

FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)

#
#  Add libraries
#
TARGET_LINK_LIBRARIES(${target} vtkFiltering vtkHybrid vtkRendering) 
#
#  Optional libraries
#
IF(VTK_KITS MATCHES "PARALLEL")
	TARGET_LINK_LIBRARIES(${target} vtkParallel) 
ENDIF(VTK_KITS MATCHES "PARALLEL")
IF(VTK_KITS MATCHES "PATENTED")
	TARGET_LINK_LIBRARIES(${target} vtkPatented) 
ENDIF(VTK_KITS MATCHES "PATENTED")
#
#  VTK 5 libraries
#
IF(VTK_KITS MATCHES "WIDGETS")
	TARGET_LINK_LIBRARIES(${target} vtkWidgets) 
ENDIF(VTK_KITS MATCHES "WIDGETS")
IF(VTK_KITS MATCHES "VOLUMERENDERING")
	TARGET_LINK_LIBRARIES(${target} vtkVolumeRendering) 
ENDIF(VTK_KITS MATCHES "VOLUMERENDERING")

IF(addOGL)
	TARGET_LINK_LIBRARIES(${target} ${OPENGL_LIBRARIES}) 
ENDIF(addOGL)

IF(UNIX AND addX11)
	TARGET_LINK_LIBRARIES(${target} ${X11_LIBRARIES})
ENDIF(UNIX AND addX11)

IF(Shell:QT)
	IF(QT_LIBRARIES)
		TARGET_LINK_LIBRARIES(${target} ${QT_LIBRARIES}) 
	ENDIF(QT_LIBRARIES)
	IF(QT4_INSTALLED)
		TARGET_LINK_LIBRARIES(${target} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QT3SUPPORT_LIBRARY} ${QT_QTOPENGL_LIBRARY}) 
		IF (WIN32)
			FIND_LIBRARY(QT_QTMAIN_LIBRARY qtmain ${QT_LIBRARY_DIR} DOC "This Library is only needed by and included with Qt on MSWindows. It should be NOTFOUND, undefined or IGNORE otherwise.")
			IF(QT_QTMAIN_LIBRARY)
				TARGET_LINK_LIBRARIES(${target} ${QT_QTMAIN_LIBRARY}) 
			ELSE(QT_QTMAIN_LIBRARY)
				MESSAGE(FATAL_ERROR "Qt Main library qtmain.lib is not found.")
			ENDIF(QT_QTMAIN_LIBRARY)
		ENDIF (WIN32)
	ENDIF(QT4_INSTALLED)
ENDIF(Shell:QT)

IF(Shell:CL)
	IF(UNIX)
		TARGET_LINK_LIBRARIES(${target} curses) 
	ENDIF(UNIX)
ENDIF(Shell:CL)

## ifrit 3.2.0

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#  Copyright (c) 2002-2006 Nick Gnedin 
+#  Copyright (c) 2002-2007 Nick Gnedin 
 #  All rights reserved.
 #
 #  This file may be distributed and/or modified under the terms of the
@@ -13,9 +13,10 @@
 SET(target ifrit)
 PROJECT(${target})
 
-SET(addOGL 0 CACHE BOOL "Add OpenGL manually")
-SET(addX11 0 CACHE BOOL "Add X11 manualy")
-MARK_AS_ADVANCED(addOGL addX11)
+SET(AddOGL 0 CACHE BOOL "Add OpenGL manually")
+SET(AddX11 0 CACHE BOOL "Add X11 manualy")
+SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
+MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -30,7 +31,11 @@
 #
 #  Shells
 #
-OPTION(Shell:CL "Include command-line shell" ON)
+IF(WIN32)
+	OPTION(Shell:CL "Include command-line shell" OFF)
+ELSE(WIN32)
+	OPTION(Shell:CL "Include command-line shell" ON)
+ENDIF(WIN32)
 OPTION(Shell:QT "Include Qt-based GUI shell" ON)
 
 SET(nsh)
@@ -49,26 +54,56 @@
 ENDIF(NOT nsh AND NOT gsh)
 
 #
-#  Extensions
-#
-FILE(GLOB dir ${src}/core/extensions/hart) 
-IF(EXISTS ${dir})
-	OPTION(Extension:HART "Include HART extension" ON)
-ENDIF(EXISTS ${dir})
-
-FILE(GLOB dir ${src}/core/extensions/mv) 
-IF(EXISTS ${dir})
-	OPTION(Extension:MultiView "Include MultiView extension" ON)
-ENDIF(EXISTS ${dir})
-
+#  Find max extension flag
+#
+SET(maxNum 1)
+FILE(READ ${src}/configure/iextensiondefines.h f)
+
+STRING(REGEX MATCHALL "#define IEXTENSION_[A-Z0-9_]*[ \t]*[0-9]*" m ${f})
+IF(m)
+	STRING(REGEX REPLACE "#define IEXTENSION_[A-Z0-9_]*[ \t]*([0-9]*)" "\\1;" num ${m})
+	SET(num ${num}0)
+	FOREACH(n ${num})
+		IF(n GREATER ${maxNum})
+			SET(maxNum ${n})
+		ENDIF(n GREATER ${maxNum})
+	ENDFOREACH(n ${num})
+ENDIF(m)
+
+#
+#  Configure extensions
+#
 SET(ext)
-IF(Extension:HART)
-	SET(ext ${ext} hart)
-ENDIF(Extension:HART)
-
-IF(Extension:MultiView)
-	SET(ext ${ext} mv)
-ENDIF(Extension:MultiView)
+FILE(GLOB dir ${src}/configure/.CMake.*.def)
+
+IF(dir)
+	FOREACH(s ${dir})
+		STRING(REGEX REPLACE ".*\\.CMake\\.([A-Z0-9_]*)\\.def" "\\1" e ${s}) 
+		IF(e STREQUAL MV)
+			OPTION(Extension:MultiView "Include MultiView extension" OFF)
+			IF(Extension:MultiView)
+				set(ext ${ext} ${e})
+			ENDIF(Extension:MultiView)
+		ELSE(e STREQUAL MV)
+			OPTION(Extension:${e} "Include ${e} extension" ON)
+			IF(Extension:${e})
+				set(ext ${ext} ${e})
+			ENDIF(Extension:${e})
+#
+#  Check that the define for this extension has been set already.
+#			
+			STRING(REGEX MATCH "#define IEXTENSION_${e}[ \t]*[0-9]*" m ${f})
+			IF(NOT m)
+
+				MESSAGE("Extension ${e} has not been defined in configure/iextensiondefines.h.\n I will define it for you.")
+				SET(maxNum 2*${maxNum})
+				FILE(APPEND ${src}/configure/iextensiondefines.h "#define IEXTENSION_${e} ${maxNum}\n")
+
+			ENDIF(NOT m)
+
+		ENDIF(e STREQUAL MV)
+	ENDFOREACH(s ${dir})
+ENDIF(dir)
 
 #
 # ---------------------------------------------------------------------------
@@ -101,22 +136,22 @@
 ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
 
 # Find OpenGL
-IF(addOGL)
+IF(AddOGL)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)
 	IF(NOT OPENGL_FOUND)
 		MESSAGE(FATAL_ERROR "OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
 	ENDIF(NOT OPENGL_FOUND)
 	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
-ENDIF(addOGL)
+ENDIF(AddOGL)
 
 # Find X11
-IF(UNIX AND addX11)
+IF(UNIX AND AddX11)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
 	IF(NOT X11_FOUND)
 		MESSAGE(FATAL_ERROR "X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
 	ENDIF(NOT X11_FOUND)
 	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
-ENDIF(UNIX AND addX11)
+ENDIF(UNIX AND AddX11)
 
 IF(Shell:QT)
 	# Find Qt
@@ -169,18 +204,7 @@
 #  Extensions
 #
 FOREACH(e ${ext})
-	FILE(GLOB tmp ${src}/core/extensions/${e}/*.cpp)
-	IF(tmp)
-		SET(sources ${sources} ${tmp})
-		INCLUDE_DIRECTORIES(${src}/core/extensions/${e})
-		IF(gsh)
-			FILE(GLOB tmp ${src}/shells/generic/extensions/${e}/*.cpp)
-			SET(sources ${sources} ${tmp})
-			INCLUDE_DIRECTORIES(${src}/shells/generic/extensions/${e})
-		ENDIF(gsh)
-		STRING(TOUPPER ${e} ue)
-		SET(exten ${exten}+IEXTENSION_${ue})
-	ENDIF(tmp)
+	SET(exten ${exten}+IEXTENSION_${e})
 ENDFOREACH(e)
 
 #
@@ -225,6 +249,10 @@
 	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK2)
 ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")
 
+IF(UseOffScreen)
+	ADD_DEFINITIONS(-DI_OFFSCREEN)
+ENDIF(UseOffScreen)
+
 #
 #  Edition
 #
@@ -259,13 +287,13 @@
 	TARGET_LINK_LIBRARIES(${target} vtkVolumeRendering) 
 ENDIF(VTK_KITS MATCHES "VOLUMERENDERING")
 
-IF(addOGL)
+IF(AddOGL)
 	TARGET_LINK_LIBRARIES(${target} ${OPENGL_LIBRARIES}) 
-ENDIF(addOGL)
-
-IF(UNIX AND addX11)
+ENDIF(AddOGL)
+
+IF(UNIX AND AddX11)
 	TARGET_LINK_LIBRARIES(${target} ${X11_LIBRARIES})
-ENDIF(UNIX AND addX11)
+ENDIF(UNIX AND AddX11)
 
 IF(Shell:QT)
 	IF(QT_LIBRARIES)

## ifrit 3.2.8

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,11 @@
 #  packaging of this file.
 #
 CMAKE_MINIMUM_REQUIRED(VERSION 2.0)
+
+IF(COMMAND cmake_policy)
+	cmake_policy(SET CMP0003 NEW)
+ENDIF(COMMAND cmake_policy)
+
 
 SET(src ..)
 SET(target ifrit)

## ifrit 3.3.2

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,15 @@
 SET(AddX11 0 CACHE BOOL "Add X11 manualy")
 SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
 MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
+
+SET(StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
+
+#
+#  Portability options
+#
+SET(Port:NoLongLong  0 CACHE BOOL "Do not use long long type")
+SET(Port:NoConsoleIO 0 CACHE BOOL "Disable console IO (must be set if conio.h include is not available)")
+MARK_AS_ADVANCED(Port:NoLongLong Port:NoConsoleIO)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -164,7 +173,7 @@
 	INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
 	INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR})
 	IF(QT4_INSTALLED)
-		INCLUDE_DIRECTORIES(${QT_QT_INCLUDE_DIR})
+		INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR}/Qt ${QT_QTCORE_INCLUDE_DIR})
 	ENDIF(QT4_INSTALLED)
 	ADD_DEFINITIONS(${QT_DEFINITIONS})
 ENDIF(Shell:QT)
@@ -268,6 +277,21 @@
 
 FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
 CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)
+
+IF(NOT StereoSupport)
+	ADD_DEFINITIONS(-DI_NO_STEREO)
+ENDIF(NOT StereoSupport)
+
+#
+#  Portability
+#
+IF(Port:NoLongLong)
+	ADD_DEFINITIONS(-DI_NO_LONG_LONG)
+ENDIF(Port:NoLongLong)
+
+IF(Port:NoConsoleIO)
+	ADD_DEFINITIONS(-DI_NO_CONSOLE_IO)
+ENDIF(Port:NoConsoleIO)
 
 #
 #  Add libraries

## ifrit 3.3.4

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -18,19 +18,16 @@
 SET(target ifrit)
 PROJECT(${target})
 
-SET(AddOGL 0 CACHE BOOL "Add OpenGL manually")
-SET(AddX11 0 CACHE BOOL "Add X11 manualy")
-SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
-MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
-
-SET(StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
+SET(Option:OffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
+SET(Option:StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
 
 #
 #  Portability options
 #
+SET(Port:SearchOGL 0 CACHE BOOL "Search for OpenGL (normally should be found automatically)")
+SET(Port:SearchX11 0 CACHE BOOL "Search for X11 (normally should be found automatically)")
 SET(Port:NoLongLong  0 CACHE BOOL "Do not use long long type")
-SET(Port:NoConsoleIO 0 CACHE BOOL "Disable console IO (must be set if conio.h include is not available)")
-MARK_AS_ADVANCED(Port:NoLongLong Port:NoConsoleIO)
+MARK_AS_ADVANCED(Port:SearchOGL Port:SearchX11 Port:NoLongLong)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -130,12 +127,12 @@
 MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY CMAKE_INSTALL_PREFIX LIBRARY_OUTPUT_PATH QT_QMAKE_EXECUTABLE)
 
 # Find curses
-INCLUDE(${CMAKE_ROOT}/Modules/FindCurses.cmake)
-IF(UNIX AND NOT CURSES_LIBRARY)
-	IF(Shell:CL)
-		MESSAGE(FATAL_ERROR "Curses library is not found, but is needed for Command-Line Shell. Please disable the Command-Line Shell option or install the curses library.")
-	ENDIF(Shell:CL)
-ENDIF(UNIX AND NOT CURSES_LIBRARY)
+IF(Shell:CL)
+	INCLUDE(${CMAKE_ROOT}/Modules/FindCurses.cmake)
+	IF(UNIX AND CURSES_LIBRARY)
+		ADD_DEFINITIONS(-DI_USE_CURSES)
+	ENDIF(UNIX AND CURSES_LIBRARY)
+ENDIF(Shell:CL)
 
 # Find VTK
 SET(VTK_DIR $ENV{VTKDIR})
@@ -150,22 +147,22 @@
 ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
 
 # Find OpenGL
-IF(AddOGL)
+IF(Port:SearchOGL)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)
 	IF(NOT OPENGL_FOUND)
 		MESSAGE(FATAL_ERROR "OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
 	ENDIF(NOT OPENGL_FOUND)
 	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
-ENDIF(AddOGL)
+ENDIF(Port:SearchOGL)
 
 # Find X11
-IF(UNIX AND AddX11)
+IF(UNIX AND Port:SearchX11)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
 	IF(NOT X11_FOUND)
 		MESSAGE(FATAL_ERROR "X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
 	ENDIF(NOT X11_FOUND)
 	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
-ENDIF(UNIX AND AddX11)
+ENDIF(UNIX AND Port:SearchX11)
 
 IF(Shell:QT)
 	# Find Qt
@@ -241,13 +238,6 @@
 	ENDIF(tmp)
 ENDIF(CustomVP1000)
 
-IF(WIN32 AND NOT CYGWIN)
-	FILE(GLOB tmp ${src}/special/win32/*.rc)
-	IF(tmp)
-		SET(sources ${sources} ${tmp})
-	ENDIF(tmp)
-ENDIF(WIN32 AND NOT CYGWIN)
-
 #
 #  Create target
 #
@@ -263,9 +253,9 @@
 	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK2)
 ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")
 
-IF(UseOffScreen)
+IF(Option:OffScreen)
 	ADD_DEFINITIONS(-DI_OFFSCREEN)
-ENDIF(UseOffScreen)
+ENDIF(Option:OffScreen)
 
 #
 #  Edition
@@ -278,9 +268,9 @@
 FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
 CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)
 
-IF(NOT StereoSupport)
+IF(NOT Option:StereoSupport)
 	ADD_DEFINITIONS(-DI_NO_STEREO)
-ENDIF(NOT StereoSupport)
+ENDIF(NOT Option:StereoSupport)
 
 #
 #  Portability
@@ -288,10 +278,6 @@
 IF(Port:NoLongLong)
 	ADD_DEFINITIONS(-DI_NO_LONG_LONG)
 ENDIF(Port:NoLongLong)
-
-IF(Port:NoConsoleIO)
-	ADD_DEFINITIONS(-DI_NO_CONSOLE_IO)
-ENDIF(Port:NoConsoleIO)
 
 #
 #  Add libraries
@@ -342,8 +328,8 @@
 ENDIF(Shell:QT)
 
 IF(Shell:CL)
-	IF(UNIX)
+	IF(UNIX AND CURSES_LIBRARY)
 		TARGET_LINK_LIBRARIES(${target} curses) 
-	ENDIF(UNIX)
+	ENDIF(UNIX AND CURSES_LIBRARY)
 ENDIF(Shell:CL)

## ifrit 3.4.2

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -237,6 +237,14 @@
 		ADD_DEFINITIONS(-DI_CUSTOM_VP1000)
 	ENDIF(tmp)
 ENDIF(CustomVP1000)
+
+IF(Extension:ART)
+	FILE(GLOB tmp ${src}/special/artio/*.c)
+	IF(tmp)
+		SET(sources ${sources} ${tmp})
+		INCLUDE_DIRECTORIES(${src}/special/artio)
+	ENDIF(tmp)
+ENDIF(Extension:ART)
 
 #
 #  Create target

=== debian/changelog ===
ifrit (3.4.2-1) unstable; urgency=low

  * QA upload.
  * New upstream release.
    + Drop existing patches.
  * Patch to link in libGL. (Closes: #713651).
  * Move debian/rules to dh style with cmake.
  * Move to source format 3.0 (quilt).
  * Add watch file.
  * Make VCS tag canonical.
  * Bump debhelper build-dep and compat to 9.
  * Bump Standards Version to 3.9.4.

 -- Barry deFreese <bdefreese@debian.org>  Thu, 11 Jul 2013 10:06:04 -0400

ifrit (3.3.4-4) unstable; urgency=low

  * QA upload.

  [ Ilya Barygin ]
  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 May 2013 16:18:57 +0100

ifrit (3.3.4-3) unstable; urgency=low

  * QA upload.
  * Fix "ftbfs with GCC-4.7": add patch 02-gcc-4.7.diff:
    declare SortWorker before using it.
    (Closes: #667207)
  * debian/rules: add build-{arch,indep} targets.

 -- gregor herrmann <gregoa@debian.org>  Wed, 02 May 2012 18:10:13 +0200

ifrit (3.3.4-2) unstable; urgency=low

  * QA upload.
  * Remove debian/watch. Upstream now links to Google Docs
    for download. I see now way to put that in a watch file.
  * vtk-tcl seems to have been renamed to tcl-vtk. Change
    Depends. (Closes: #619916)
  * Update homepage link.
  * Remove patch to allow build against VTK 5.4. 5.6 is used now.

 -- Frank Lichtenheld <djpig@debian.org>  Sat, 09 Apr 2011 14:36:03 +0200

ifrit (3.3.4-1) unstable; urgency=low

  * New upstream release.  Closes: #614433.
  * Rebuild against libqt4.  Closes: #604588.
  * Don't hardcode VTK version, no longer necessary.
  * Update debian/copyright.  Closes: #566582.
  * Orphan package.

 -- Mark Hymers <mhy@debian.org>  Fri, 18 Mar 2011 23:04:13 +0000

ifrit (3.3.2-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.8.3.  No changes needed.

 -- Mark Hymers <mhy@debian.org>  Sun, 13 Sep 2009 14:53:24 +0100

ifrit (3.2.8-1) unstable; urgency=low

  * New upstream release.

 -- Mark Hymers <mhy@debian.org>  Sun, 13 Sep 2009 13:41:27 +0100

ifrit (3.2.7-1) unstable; urgency=low

  * Add myself to Uploaders.
  * New upstream release for compatibility with VTK 5.2.
  * Update VTKDIR in debian/rules to /usr/lib/vtk-5.2. (Closes: #536904)
  * Drop RPATH from /usr/bin/ifrit.
  * Bump debhelper compatibility level to 7.
    - Add ${misc:Depends} to ifrit binary package.
    - Replace usages of deprecated `dh_clean -k` with `dh_prep`.
    - Remove calls to dh_desktop - it is a no-op now.
  * Add 01-gcc-4.3.diff to fix compilation with GCC 4.3.
  * Bump Standards-Version to 3.8.2.
  * Drop "Encoding=UTF-8" in debian/ifrit.desktop - it is now the default.
  * Clean CVS conflict files left in upstream tarball.
  * Add debian/watch file.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Aug 2009 12:29:10 +0100

ifrit (3.2.5-1) unstable; urgency=low

  * New upstream release.
  * Add Vcs-Browser and Vcs-Git fields.

 -- Mark Hymers <mhy@debian.org>  Sat, 28 Jun 2008 16:42:51 +0100

ifrit (3.2.4-1) unstable; urgency=low

  * New upstream release.
  * Remove dpatch support.
  * Bump Standards-Version to 3.8.0.

 -- Mark Hymers <mhy@debian.org>  Sun, 15 Jun 2008 21:33:02 +0100

ifrit (3.2.2-2) unstable; urgency=low

  * The "Running lintian on the right file considered helpful" release.
  * Move Homepage to source stanza
  * Use Applications/Science/Data Analysis as the menu section 

 -- Mark Hymers <mhy@debian.org>  Sat, 22 Dec 2007 17:51:09 +0000

ifrit (3.2.2-1) unstable; urgency=low

  * New upstream release.
  * Add patch to fix building with gcc-4.3.  Closes: #455164.
  * Bump Standards-Version to 3.7.3.
  * Move menu entry into Applications/Science instead of Apps/Science

 -- Mark Hymers <mhy@debian.org>  Wed, 19 Dec 2007 12:05:27 +0000

ifrit (3.2.0-1) unstable; urgency=low

  * New upstream release. 

 -- Mark Hymers <mhy@debian.org>  Fri, 31 Aug 2007 13:40:20 +0100

ifrit (3.1.5-1) unstable; urgency=low

  * New upstream release.  Closes: #420042.

 -- Mark Hymers <mhy@debian.org>  Sun, 22 Jul 2007 18:51:30 +0100

ifrit (3.1.0-1) unstable; urgency=low

  * New upstream version.
  * The "I'm bound to screw up my first non-sponsored upload" release.
  * Use VERBOSE=1 in make call so that buildd logs are useful.
  * Change VTKDIR to use /usr/lib/vtk-5.0 directly as /usr/lib/vtk
    appears not to be supplied now.  Yes, this'll make VTK changes
    more painful.
  * Add 01_no_patented.dpatch so we don't try and use any of the VTK
    patented interfaces which aren't in the Debian package.

 -- Mark Hymers <mhy@debian.org>  Sat,  7 Apr 2007 19:56:43 +0100

ifrit (3.0.5-1) unstable; urgency=low

  * New upstream version. 

 -- Mark Hymers <mark@hymers.org.uk>  Sat, 28 Oct 2006 15:06:32 +0100

ifrit (3.0.0-1) unstable; urgency=low

  * New upstream version.  Closes: #385517.

 -- Mark Hymers <mark@hymers.org.uk>  Wed, 30 Aug 2006 16:08:14 +0100

ifrit (2.9.6-2) unstable; urgency=low

  * Add a .desktop file from Phil Bull via Barry deFreese and Ubuntu.  Thanks
    to all concerned.  Closes: #376927.  Also add a dh_desktop call.
  * Bump standards version to 3.7.2.  No changes.

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Sat, 15 Jul 2006 16:10:54 +0100

ifrit (2.9.6-1) unstable; urgency=low

  * New upstream release.
  * Upstream has included Martin Michlmayr's patch to fix building on
    g++-4.1.  Closes: #357340.
  * Add -Wl,--as-needed as a flag to the link stage to reduce the
    number of libraries ifrit directly depends on (see
    http://lists.debian.org/debian-devel-announce/2005/11/msg00016.html
    for details)

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Fri, 17 Mar 2006 14:03:56 +0000

ifrit (2.9.4-1) unstable; urgency=low

  * New upstream release.

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Sat, 26 Nov 2005 14:02:48 +0000

ifrit (2.9.3-2) unstable; urgency=low

  * Rebuild for the C++ transition; needs vtk >= 4.4.2-8.  Closes: #327937
  * Newer version of debhelper will install menu file in /usr/share/menu


=== debian/control ===
Source: ifrit
Section: science
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 9), libvtk5-dev, libqt4-dev, libqt4-opengl-dev, cmake, libncurses5-dev, libtiff-dev, chrpath
Standards-Version: 3.9.4
Homepage: http://sites.google.com/site/ifrithome/
Vcs-Browser: http://git.debian.org/git/users/mhy/ifrit.git
Vcs-Git: git://anonscm.debian.org/users/mhy/ifrit.git

Package: ifrit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, tcl-vtk
Description: powerful tool for visualizing 3-dimensional data sets
 IFRIT (the Ionization FRont Interactive Tool) has its origins (and
 hence name) in a specialized utility designed to visualize ionization
 fronts in cosmological numerical simulations.  IFRIT, however, has
 outgrown its origins and now can visualize general data sets as well.
 .
 IFRIT is written in C++ and is based on two state-of-the-art toolkits:
 the Visualization ToolKit (VTK) and a GUI toolkit QT.

=== debian/watch ===
version=3
http://astro.uchicago.edu/%7Egnedin/IFRIT/ifrit-src\.(.+)\.tar\.gz

## ifrit 4.1.2

=== build/CMakeLists.txt ===
#
#  Copyright (c) 2002-2015 Nick Gnedin 
#  All rights reserved.
#
#  This file may be distributed and/or modified under the terms of the
#  GNU General Public License version 2 as published by the Free Software
#  Foundation and appearing in the file LICENSE.GPL included in the
#  packaging of this file.
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8)

IF(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)


SET(src ..)
PROJECT(IFrIT)

SET(Option:StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")

#
#  Portability options
#
SET(Port:SearchOGL 0 CACHE BOOL "Search for OpenGL (normally should be found automatically)")
SET(Port:SearchX11 0 CACHE BOOL "Search for X11 (normally should be found automatically)")
SET(Port:NoLongLong  0 CACHE BOOL "Do not use long long type")
SET(Port:Debian  0 CACHE BOOL "Do not use long long type")
MARK_AS_ADVANCED(Port:SearchOGL Port:SearchX11 Port:NoLongLong)

IF(NOT CMAKE_BUILD_TYPE)
       SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

#
# ---------------------------------------------------------------------------
#
# Configuration
#
# ---------------------------------------------------------------------------
#
#  Shells
#
IF(WIN32)
	OPTION(Shell:CL "Include command-line shell" OFF)
ELSE(WIN32)
	OPTION(Shell:CL "Include command-line shell" ON)
ENDIF(WIN32)
OPTION(Shell:QT "Include Qt-based GUI shell" ON)
OPTION(Shell:OS "Include off-screen shell" ON)

SET(tty_shells)
SET(gui_shells)

IF(Shell:CL)
	SET(tty_shells ${tty_shells} cl)
ENDIF(Shell:CL)

IF(Shell:OS)
	SET(tty_shells ${tty_shells} os)
ENDIF(Shell:OS)

IF(Shell:QT)
	SET(gui_shells ${gui_shells} qt)
ENDIF(Shell:QT)

IF(NOT tty_shells AND NOT gui_shells)
	MESSAGE(FATAL_ERROR "At least one shell must be selected.")
ENDIF(NOT tty_shells AND NOT gui_shells)

#
#  Scripts
#
OPTION(Script:PY "Use Python as scripting language" ON)

SET(scripts)

IF(Script:PY)
	SET(scripts ${scripts} python)
ENDIF(Script:PY)

IF(NOT scripts)
	MESSAGE("No scripting language is selected - IFrIT will not be able to use scripts.")
ENDIF(NOT scripts)

IF(Shell:OS AND NOT scripts)
	MESSAGE(FATAL_ERROR "The off-screen shell will not work without a script.")
ENDIF(Shell:OS AND NOT scripts)

#
#  Find max extension flag
#
SET(maxNum 1)
FILE(READ ${src}/configure/iextensiondefines.h f)

STRING(REGEX MATCHALL "#define IEXTENSION_[A-Z0-9_]*[ \t]*[0-9]*" m ${f})
IF(m)
	STRING(REGEX REPLACE "#define IEXTENSION_[A-Z0-9_]*[ \t]*([0-9]*)" "\\1;" num ${m})
	SET(num ${num}0)
	FOREACH(n ${num})
		IF(n GREATER ${maxNum})
			SET(maxNum ${n})
		ENDIF(n GREATER ${maxNum})
	ENDFOREACH(n ${num})
ENDIF(m)

#
#  Configure extensions
#
SET(extensions)
FILE(GLOB dir ${src}/build/install.*.cpp)

IF(dir)
	FOREACH(s ${dir})
		STRING(REGEX REPLACE "^.*install\\.([A-Z0-9_]*)\\.cpp" "\\1" e ${s}) 
		OPTION(Extension:${e} "Include ${e} extension" ON)
		IF(Extension:${e})
			set(extensions ${extensions} ${e})
		ENDIF(Extension:${e})
#
#  Check that the define for this extension has been set already.
#			
		STRING(REGEX MATCH "#define IEXTENSION_${e}[ \t]*[0-9]*" m ${f})
		IF(NOT m)

			MESSAGE("Extension ${e} has not been defined in configure/iextensiondefines.h.\n I will define it for you.")
			SET(maxNum 2*${maxNum})
			FILE(APPEND ${src}/configure/iextensiondefines.h "#define IEXTENSION_${e} ${maxNum}\n")

		ENDIF(NOT m)

	ENDFOREACH(s ${dir})
ENDIF(dir)

#
# ---------------------------------------------------------------------------
#
#  Find dependencies
#
# ---------------------------------------------------------------------------
#
# Find VTK
FIND_PACKAGE(VTK REQUIRED)
IF(NOT VTK_FOUND)
	MESSAGE(FATAL_ERROR " VTK is not found. Please check that VTKDIR variables is set properly.")
ENDIF(NOT VTK_FOUND)
INCLUDE(${VTK_USE_FILE})

IF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
	OPTION(CustomVP1000 "Include custom support for VP1000" ON)
ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)

# Find OpenGL
IF(Port:SearchOGL)
	FIND_PACKAGE(OPENGL REQUIRED)
	IF(NOT OPENGL_FOUND)
		MESSAGE(FATAL_ERROR " OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
	ENDIF(NOT OPENGL_FOUND)
	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
ENDIF(Port:SearchOGL)

# Find X11
IF(UNIX AND Port:SearchX11)
	FIND_PACKAGE(X11 REQUIRED)
	IF(NOT X11_FOUND)
		MESSAGE(FATAL_ERROR " X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
	ENDIF(NOT X11_FOUND)
	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
ENDIF(UNIX AND Port:SearchX11)

IF(Shell:QT)
	# Find Qt
	SET(QT_REQUIRED 1)
	INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
	INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR})
	IF(QT4_INSTALLED)
		INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR}/QtCore)
	ENDIF(QT4_INSTALLED)
	ADD_DEFINITIONS(${QT_DEFINITIONS})
ENDIF(Shell:QT)

IF(Script:PY)
	# Find Python
	SET(Python_ADDITIONAL_VERSIONS 3.4 3.3 3.2 3.1 3.0)
	INCLUDE(${CMAKE_ROOT}/Modules/FindPythonLibs.cmake)
	IF(PYTHONLIBS_FOUND)
		IF(PYTHONLIBS_VERSION_STRING STRLESS "2.7.0")
			MESSAGE(FATAL_ERROR " IFrIT needs Python 2.7 and higher. Please upgrade your Python installation.")
		ENDIF(PYTHONLIBS_VERSION_STRING STRLESS "2.7.0")
		INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})

		SET(BuildPythonModule 0 CACHE BOOL "Build and install a shared library for Python import. That requires that all VTK, Qt, and Python libraries are built as shared objects.")

	ELSE(PYTHONLIBS_FOUND)
		MESSAGE(FATAL_ERROR " Python is not found. Install Python on your system or uncheck Script:PY option")
	ENDIF(PYTHONLIBS_FOUND)
ENDIF(Script:PY)

#
# ---------------------------------------------------------------------------
#
#  Create the project
#
# ---------------------------------------------------------------------------
#
SET(my_shl 0)
SET(my_scr 0)
SET(my_ext 0)
#
#  Core
#
FILE(GLOB sources ${src}/configure/*.cpp ${src}/core/*.cpp ${src}/help/*.cpp)
INCLUDE_DIRECTORIES(${src}/configure ${src}/core ${src}/help ${src}/docs)

#
#  Shells
#
IF(gui_shells)
	FILE(GLOB tmp ${src}/shells/configure/*.cpp ${src}/shells/generic/*.cpp ${src}/shells/base/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/shells/configure ${src}/shells/generic ${src}/shells/base)
	ENDIF(tmp)
ENDIF(gui_shells)

FOREACH(s ${tty_shells} ${gui_shells})
	FILE(GLOB tmp ${src}/shells/${s}/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/shells/${s})
		STRING(TOUPPER ${s} us)
		SET(my_shl ${my_shl}+ISHELL_${us})
	ENDIF(tmp)
ENDFOREACH(s)

#
#  Scripts
#
IF(scripts)
	FILE(GLOB tmp ${src}/scripts/configure/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/scripts/configure)
	ENDIF(tmp)
ENDIF(scripts)

FOREACH(s ${scripts})
	FILE(GLOB tmp ${src}/scripts/${s}/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/scripts/${s})
		STRING(TOUPPER ${s} us)
		SET(my_scr ${my_scr}+ISCRIPT_${us})
	ENDIF(tmp)
ENDFOREACH(s)

#
#  Extensions
#
FOREACH(e ${extensions})
	SET(my_ext ${my_ext}+IEXTENSION_${e})
ENDFOREACH(e)

FILE(GLOB tmp ${src}/core/imultiviewrendertool.cpp)
IF(tmp)
	SET(my_ext ${my_ext}+IEXTENSION_MV)
ENDIF(tmp)

#
#  Special
#
IF(Shell:QT)
	SET(qtdir ${src}/shells/qt)
	SET(qthdr ${qtdir}/iqtwidgettexteditorsubject.h ${qtdir}/iqtwidgethelper.h ${qtdir}/iqtrenderwindowsubject.h ${qtdir}/iqtmenuwindowsubject.h ${qtdir}/iqtmainwindowsubject.h ${qtdir}/iqtframesubject.h)
	SET(tmp)
	QT_WRAP_CPP(dummy tmp ${qthdr})
	SET(sources ${sources} ${tmp})
ENDIF(Shell:QT)

IF(CustomVP1000)
	FILE(GLOB tmp ${src}/special/vp1000/*.cpp)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/special/vp1000)
		ADD_DEFINITIONS(-DI_CUSTOM_VP1000)
	ENDIF(tmp)
ENDIF(CustomVP1000)

IF(Extension:ART)
	FILE(GLOB tmp ${src}/special/artio/*.c)
	IF(tmp)
		SET(sources ${sources} ${tmp})
		INCLUDE_DIRECTORIES(${src}/special/artio)
	ENDIF(tmp)
ENDIF(Extension:ART)


ADD_DEFINITIONS(-DI_EXTERNAL_CONFIGURATION)

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK)
ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")

#
#  Edition
#
FILE(GLOB tmp ${src}/configure/edition*.cpp)
IF(tmp) 
	ADD_DEFINITIONS(-DI_EDITION)
ENDIF(tmp) 

FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)

IF(NOT Option:StereoSupport)
	ADD_DEFINITIONS(-DI_NO_STEREO)
ENDIF(NOT Option:StereoSupport)

#
#  Portability
#
IF(Port:NoLongLong)
	ADD_DEFINITIONS(-DI_NO_LONG_LONG)
ENDIF(Port:NoLongLong)
IF(Port:Debian)
	ADD_DEFINITIONS(-DI_PORT_DEBIAN)
ENDIF(Port:Debian)

#
#  Add libraries
#
FUNCTION(link target)
TARGET_LINK_LIBRARIES(${target} ${VTK_LIBRARIES}) 

IF(Port:SearchOGL)
	TARGET_LINK_LIBRARIES(${target} ${OPENGL_LIBRARIES}) 
ENDIF(Port:SearchOGL)

IF(UNIX AND Port:SearchX11)
	TARGET_LINK_LIBRARIES(${target} ${X11_LIBRARIES})
ENDIF(UNIX AND Port:SearchX11)

IF(Shell:QT)
	IF(QT_LIBRARIES)
		TARGET_LINK_LIBRARIES(${target} ${QT_LIBRARIES}) 
	ENDIF(QT_LIBRARIES)
	IF(QT4_INSTALLED)
		TARGET_LINK_LIBRARIES(${target} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QT3SUPPORT_LIBRARY} ${QT_QTOPENGL_LIBRARY}) 
		IF (WIN32)
			FIND_LIBRARY(QT_QTMAIN_LIBRARY qtmain ${QT_LIBRARY_DIR} DOC "This Library is only needed by and included with Qt on MSWindows. It should be NOTFOUND, undefined or IGNORE otherwise.")
			IF(QT_QTMAIN_LIBRARY)
				TARGET_LINK_LIBRARIES(${target} ${QT_QTMAIN_LIBRARY}) 
			ELSE(QT_QTMAIN_LIBRARY)
				MESSAGE(FATAL_ERROR " Qt Main library qtmain.lib is not found.")
			ENDIF(QT_QTMAIN_LIBRARY)
		ENDIF (WIN32)
	ENDIF(QT4_INSTALLED)
ENDIF(Shell:QT)

IF(Script:PY)
	TARGET_LINK_LIBRARIES(${target} ${PYTHON_LIBRARIES})
	IF(UNIX)
		TARGET_LINK_LIBRARIES(${target} util)
	ENDIF(UNIX)
ENDIF(Script:PY)
ENDFUNCTION(link)

#
#  Create targets
#
FILE(GLOB dir install.*.cpp)

ADD_LIBRARY(temp STATIC ${sources})
SET_TARGET_PROPERTIES(temp PROPERTIES POSITION_INDEPENDENT_CODE true)
link(temp)

IF(tty_shells)
	ADD_EXECUTABLE(ifrit ifrit.cpp ${dir})
ELSE(tty_shells)
	ADD_EXECUTABLE(ifrit WIN32 ifrit.cpp ${dir})
ENDIF(tty_shells)
SET_TARGET_PROPERTIES(ifrit PROPERTIES RUNTIME_OUTPUT_DIRECTORY ..)
TARGET_LINK_LIBRARIES(ifrit temp)

INSTALL(TARGETS ifrit RUNTIME DESTINATION bin)

IF(BuildPythonModule AND PYTHON_INCLUDE_DIRS)
	ADD_LIBRARY(python SHARED python.cpp ${dir})
	SET_TARGET_PROPERTIES(python PROPERTIES PREFIX "")
	SET_TARGET_PROPERTIES(python PROPERTIES OUTPUT_NAME ifrit)
	SET_TARGET_PROPERTIES(python PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
	TARGET_LINK_LIBRARIES(python temp)

	STRING(REGEX REPLACE "libpython([0-9]\\.[0-9])[m]*\\.[a-z]*" "python\\1/site-packages" dir ${PYTHON_LIBRARIES})
	IF(EXISTS ${dir})
		INSTALL(TARGETS python LIBRARY DESTINATION ${dir})
	ELSE(EXISTS ${dir})
		MESSAGE(ERROR " Unable to find the installation directory " ${dir} " for Python module. Python module will not be installed.")
	ENDIF(EXISTS ${dir})

ENDIF(BuildPythonModule AND PYTHON_INCLUDE_DIRS)

=== debian/changelog ===
ifrit (4.1.2-6) unstable; urgency=medium

  [ Adam Borowski ]
  * QA upload.
  * R³.
  * Move the VCS to Salsa.
  * Don't handle noopt and nostrip, already done by dpkg-buildflags.

  [ Peter Michael Green ]
  * Set DESIRED_QT_VERSION to 4 through a new override_dh_auto_configure target
    + Note: the package has a target called override_dh_autoconfigure which does
      nothing due to a typo in it's name, I tried fixing said typo but that
      seemed to cause more problems than it solved.
    (Closes: #897114)

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 06 May 2018 22:10:35 +0200

ifrit (4.1.2-5) unstable; urgency=medium

  * QA upload.
  [ Gert Wollny ]
  * debian/patches/vtk63_transition.patch
    - prepare for vtk 6.3 (Closes: #821105)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Apr 2016 17:37:19 +0200

ifrit (4.1.2-4) unstable; urgency=medium

  * QA upload.
  * Revert last upload from Ralf, now vtk6 is fixed.
    (the issue was in vtk6, not in ifrit, and was affecting more
     packages)
  * Bump std-version to 3.9.8, no changes required.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 Apr 2016 10:11:38 +0200

ifrit (4.1.2-3) unstable; urgency=medium

  * QA upload
  * Add build-dependency on libhdf5-openmpi-dev (closes: #820545)

 -- Ralf Treinen <treinen@debian.org>  Sat, 09 Apr 2016 21:30:57 +0200

ifrit (4.1.2-2) unstable; urgency=medium

  * QA upload.
  * Drop hardcoded dependency on tcl-vtk.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 17 Jan 2016 16:17:19 +0100

ifrit (4.1.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release
    + Uses vtk6 (Closes: #803593)
  * Drop all quilt patches.
  * Drop the menu.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 14 Jan 2016 08:59:31 +0100

ifrit (3.4.2-2) unstable; urgency=medium

  * QA upload.
  * Use the CMake 3.2 way to find VTK.  (Closes: #788766)
  * Move packaging repository to collab-maint and import missing history.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 18 Jul 2015 18:09:06 +0200

=== debian/control ===
Source: ifrit
Section: science
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 9), libvtk6-dev, libqt4-dev, libqt4-opengl-dev, cmake, libncurses5-dev, libtiff-dev, chrpath
Standards-Version: 4.1.4
Rules-Requires-Root: no
Homepage: http://sites.google.com/site/ifrithome/
Vcs-Git: https://salsa.debian.org/debian/ifrit
Vcs-Browser: https://salsa.debian.org/debian/ifrit

Package: ifrit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: powerful tool for visualizing 3-dimensional data sets
 IFRIT (the Ionization FRont Interactive Tool) has its origins (and
 hence name) in a specialized utility designed to visualize ionization
 fronts in cosmological numerical simulations.  IFRIT, however, has
 outgrown its origins and now can visualize general data sets as well.
 .
 IFRIT is written in C++ and is based on two state-of-the-art toolkits:
 the Visualization ToolKit (VTK) and a GUI toolkit QT.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
# Modified for ifrit build by Mark Hymers 2004-2006

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


%:
	dh $@ --buildsystem=cmake --sourcedirectory=build

#this target doesn't actually do anything, because of a typo in it's name,
#i tried fixing said typo but that caused more problems than it solved --plugwash
override_dh_autoconfigure:
	cd build && cmake \
		-DDESIRED_QT_VERSION:STRING=4 \
		-DQT_LIBRARY_DIR:STRING=/usr/lib/qt4 \
		-DQT_QMAKE_EXECUTABLE:STRING=/usr/bin/qmake-qt4 \
		-DCMAKE_EXE_LINKER_FLAGS:STRING="${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed -lGL" \
		-DCMAKE_COLOR_MAKEFILE:BOOL=FALSE

override_dh_auto_configure:
	dh_auto_configure -- -DDESIRED_QT_VERSION=4

override_dh_clean:
	# Clean up stuff which make clean leaves behind
	rm -f build/CMakeCache.txt build/cmake_install.cmake build/Makefile
	rm -f configure/iconfiguresettings.ext.h
	rm -fr build/CMakeFiles build/progress.make
	rm -f configure-stamp build-stamp ifrit
	# Clean CVS junk
	find -name "\.#*" -delete
	dh_clean

override_dh_install:
	chrpath --delete ifrit
	dh_install
